package org.apache.maven.archetype.mojos;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on archetype-plugin.<br/> Call <pre>  mvn archetype:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Tue Feb 01 21:50:39 CET 2011
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.5)
 * @goal help
 * @requiresProject false
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "org.sonatype.maven.archetype:archetype-plugin:0.8.5", 0 );
        append( sb, "", 0 );

        append( sb, "Sonatype Archetype :: Plugin", 0 );
        append( sb, "(no description available)", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 8 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "add-archetype-metadata".equals( goal ) )
        {
            append( sb, "archetype:add-archetype-metadata", 0 );
            append( sb, "Inject any plugin-specific artifact metadata to the project\'s artifact, for subsequent installation and deployment. The first use-case for this is to add the LATEST metadata (which is plugin-specific) for shipping alongside the plugin\'s artifact.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "goalPrefix", 2 );
                append( sb, "The prefix for the plugin goal.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "crawl".equals( goal ) )
        {
            append( sb, "archetype:crawl", 0 );
            append( sb, "Crawl a Maven 2 repository (Filesystem, not HTTP) and creates a catalog file.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "catalogFile", 2 );
                append( sb, "The archetype\'s catalog to update.", 3 );
                append( sb, "", 0 );

                append( sb, "repository (Default: ${settings.localRepository})", 2 );
                append( sb, "The repository to crawl.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "create".equals( goal ) )
        {
            append( sb, "archetype:create", 0 );
            append( sb, "Creates sample archetype from current project.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "archetypeFilteredExtensions", 2 );
                append( sb, "File extensions which are checked for project\'s text files (vs binary files).", 3 );
                append( sb, "", 0 );

                append( sb, "archetypeLanguages", 2 );
                append( sb, "Directory names which are checked for project\'s sources main package.", 3 );
                append( sb, "", 0 );

                append( sb, "archetypeRegistryFile", 2 );
                append( sb, "The location of the registry file.", 3 );
                append( sb, "", 0 );

                append( sb, "defaultEncoding (Default: UTF-8)", 2 );
                append( sb, "Velocity templates encoding.", 3 );
                append( sb, "", 0 );

                append( sb, "interactive (Default: false)", 2 );
                append( sb, "Enable the interactive mode to define the archetype from the project.", 3 );
                append( sb, "", 0 );

                append( sb, "keepParent", 2 );
                append( sb, "Poms in archetype are created with their initial parent. This property is ignored when preserveCData is true.", 3 );
                append( sb, "", 0 );

                append( sb, "localRepository", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "packageName", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "partialArchetype", 2 );
                append( sb, "Create a partial archetype.", 3 );
                append( sb, "", 0 );

                append( sb, "preserveCData", 2 );
                append( sb, "Create pom\'s velocity templates with CDATA preservasion. This uses the String replaceAll method and risk to have some overly replacement capabilities (beware of \'1.0\' value).", 3 );
                append( sb, "", 0 );

                append( sb, "propertyFile", 2 );
                append( sb, "The property file that holds the plugin configuration.", 3 );
                append( sb, "", 0 );

                append( sb, "testMode", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "archetype:help", 0 );
            append( sb, "Display help information on archetype-plugin.\nCall\n\u00a0\u00a0mvn\u00a0archetype:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "integration-test".equals( goal ) )
        {
            append( sb, "archetype:integration-test", 0 );
            append( sb, "Execute the archetype integration tests.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "jar".equals( goal ) )
        {
            append( sb, "archetype:jar", 0 );
            append( sb, "(no description available)", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "archetypeDirectory", 2 );
                append( sb, "Directory containing the classes.", 3 );
                append( sb, "", 0 );

                append( sb, "finalName", 2 );
                append( sb, "Name of the generated JAR.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory", 2 );
                append( sb, "Directory containing the generated JAR.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "realize".equals( goal ) )
        {
            append( sb, "archetype:realize", 0 );
            append( sb, "Generates sample project from archetype.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "archetypeArtifactId", 2 );
                append( sb, "The archetype\'s artifactId.", 3 );
                append( sb, "", 0 );

                append( sb, "archetypeCatalog (Default: remote,local)", 2 );
                append( sb, "The archetype\'s catalogs. It is a comma separated list of catalogs. Catalogs use scheme: - \'file://...\' with archetype-catalog.xml automatically appended when defining a directory - \'http://...\' with archetype-catalog.xml always appended - \'local\' which is the shortcut for \'file://~/.m2/archetype-catalog.xml\' - \'remote\' which is the shortcut for \'http://repo1.maven.org/maven2\' - \'internal\' which is an internal catalog Since 2.0-alpha-5, default value is no longer internal,local but remote,local This can only work if central has a catalog file at root.", 3 );
                append( sb, "", 0 );

                append( sb, "archetypeGroupId", 2 );
                append( sb, "The archetype\'s groupId.", 3 );
                append( sb, "", 0 );

                append( sb, "archetypeRepository", 2 );
                append( sb, "The archetype\'s repository.", 3 );
                append( sb, "", 0 );

                append( sb, "archetypeVersion", 2 );
                append( sb, "The archetype\'s version.", 3 );
                append( sb, "", 0 );

                append( sb, "basedir", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "interactiveMode (Default: ${settings.interactiveMode})", 2 );
                append( sb, "User settings use to check the interactiveMode.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "update-local-catalog".equals( goal ) )
        {
            append( sb, "archetype:update-local-catalog", 0 );
            append( sb, "Updates the local catalog", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
